#include <bits/stdc++.h>
#define int long long 
using namespace std;

int suma(multiset<int>& skup){
    int tr = 0;
    int vr = 0;
    for(int x : skup){
        if(tr == 3){
            break;
        }
        vr += x;
        tr++;
    }
    return (vr * -1);
}

void Bumerang(int n, int q, int* p, int* w, int* s, int* k, long long* ans){
    multiset<int> skup;
    vector<int> a(n + 1);
    for(int i = 1; i <= n; i++){
        a[i] = w[i];
        skup.insert(-1 * w[i]);
    }
    for(int test = 1; test <= q; test++){
        int starox = a[s[test]];
        int novox = k[test];
        a[s[test]] = k[test];
        skup.erase(skup.find(-1 * starox));
        skup.insert(-1 * novox);
        ans[test] = suma(skup);
    }
}